=== debian/changelog ===
apitrace (6.1+git20150626.62ad71c6+repack-1build3) xenial; urgency=medium

  * Rebuild to get correct dependencies on s390x.

 -- Adam Conrad <adconrad@ubuntu.com>  Mon, 21 Mar 2016 13:06:10 -0600

apitrace (6.1+git20150626.62ad71c6+repack-1build2) xenial; urgency=medium

  * Rebuild for glibc-2.23.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 20 Mar 2016 11:17:53 +0100

apitrace (6.1+git20150626.62ad71c6+repack-1build1) xenial; urgency=medium

  * No-change rebuild for libprocps transition

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Tue, 08 Mar 2016 15:04:34 +1100

apitrace (6.1+git20150626.62ad71c6+repack-1) unstable; urgency=low

  * Initial release (Closes: #636679)

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Fri, 26 Jun 2015 17:25:12 +1000
